package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.VuforiaImageGroup;
import com.izouma.awesomeadmin.service.VuforiaImageGroupService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/vuforiaImageGroup")
public class VuforiaImageGroupController {

    @Autowired
    private VuforiaImageGroupService vuforiaImageGroupService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(VuforiaImageGroup record) {
        List<VuforiaImageGroup> pp = vuforiaImageGroupService.getVuforiaImageGroupList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getVuforiaImageGroup", method = RequestMethod.GET)
    @ResponseBody
    public Result getVuforiaImageGroup(@RequestParam(required = false, value = "id") String id) {
        VuforiaImageGroup data = vuforiaImageGroupService.getVuforiaImageGroupById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(VuforiaImageGroup record) {
        VuforiaImageGroup data = vuforiaImageGroupService.getVuforiaImageGroup(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, VuforiaImageGroup record) {
        Map<String, Object> result = new HashMap<>();

        List<VuforiaImageGroup> pp =vuforiaImageGroupService.getVuforiaImageGroupByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(VuforiaImageGroup record) {
        boolean num = vuforiaImageGroupService.createVuforiaImageGroup(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateVuforiaImageGroup(VuforiaImageGroup record) {
        boolean num = vuforiaImageGroupService.updateVuforiaImageGroup(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteVuforiaImageGroup(VuforiaImageGroup record) {

        boolean num = vuforiaImageGroupService.deleteVuforiaImageGroup(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, VuforiaImageGroup record) throws Exception {

    List<VuforiaImageGroup> vuforiaImageGroups = vuforiaImageGroupService.getVuforiaImageGroupList(record);


        String sheetName = "vuforia_image_group";
        String titleName = "识别图集信息数据表";
        String fileName = "识别图集信息表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "识别图数据名称" ,   "识别图集名称" ,   "备注1" ,   "备注2" ,   "备注3"  };
        String[][] dataList = new String[vuforiaImageGroups.size()][11];

        for (int i = 0; i < vuforiaImageGroups.size(); i++) {

                        dataList[i][0] = String.valueOf(vuforiaImageGroups.get(i).getId());
                        dataList[i][1] = String.valueOf(vuforiaImageGroups.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(vuforiaImageGroups.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(vuforiaImageGroups.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(vuforiaImageGroups.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(vuforiaImageGroups.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(vuforiaImageGroups.get(i).getVuforiaDataName());
                        dataList[i][7] = String.valueOf(vuforiaImageGroups.get(i).getVuforiaName());
                        dataList[i][8] = String.valueOf(vuforiaImageGroups.get(i).getRemark1());
                        dataList[i][9] = String.valueOf(vuforiaImageGroups.get(i).getRemark2());
                        dataList[i][10] = String.valueOf(vuforiaImageGroups.get(i).getRemark3());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

